/*
* This file was generated by the CommonAPI Generators.
* Used org.genivi.commonapi.core 3.2.0.v202012010850.
* Used org.franca.core 0.13.1.201807231814.
*
* This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0.
* If a copy of the MPL was not distributed with this file, You can obtain one at
* http://mozilla.org/MPL/2.0/.
*/
#ifndef V2_TEST_AUDIO_CONTROLLER_HPP_
#define V2_TEST_AUDIO_CONTROLLER_HPP_




#if !defined (COMMONAPI_INTERNAL_COMPILATION)
#define COMMONAPI_INTERNAL_COMPILATION
#define HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

#include <CommonAPI/ByteBuffer.hpp>
#include <CommonAPI/Deployment.hpp>
#include <CommonAPI/InputStream.hpp>
#include <CommonAPI/OutputStream.hpp>
#include <CommonAPI/Struct.hpp>
#include <CommonAPI/Types.hpp>
#include <cstdint>
#include <string>
#include <unordered_map>

#if defined (HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE)
#undef COMMONAPI_INTERNAL_COMPILATION
#undef HAS_DEFINED_COMMONAPI_INTERNAL_COMPILATION_HERE
#endif

namespace v2 {
namespace Test {
namespace Audio {

class Controller {
public:
    virtual ~Controller() { }

    static inline const char* getInterface();
    static inline CommonAPI::Version getInterfaceVersion();
    
    struct ErrorType : CommonAPI::Enumeration< uint8_t> {
        enum Literal : uint8_t {
            NOERROR = 0,
            ERROR = 1
        };
    
        ErrorType()
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(Literal::NOERROR)) {}
        ErrorType(Literal _literal)
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(_literal)) {}
    
        inline bool validate() const {
            switch (value_) {
                case static_cast< uint8_t>(Literal::NOERROR):
                case static_cast< uint8_t>(Literal::ERROR):
                return true;
            default:
                return false;
            }
        }
    
        inline bool operator==(const ErrorType &_other) const { return (value_ == _other.value_); }
        inline bool operator!=(const ErrorType &_other) const { return (value_ != _other.value_); }
        inline bool operator<=(const ErrorType &_other) const { return (value_ <= _other.value_); }
        inline bool operator>=(const ErrorType &_other) const { return (value_ >= _other.value_); }
        inline bool operator<(const ErrorType &_other) const { return (value_ < _other.value_); }
        inline bool operator>(const ErrorType &_other) const { return (value_ > _other.value_); }
    
        inline bool operator==(const Literal &_value) const { return (value_ == static_cast< uint8_t>(_value)); }
        inline bool operator!=(const Literal &_value) const { return (value_ != static_cast< uint8_t>(_value)); }
        inline bool operator<=(const Literal &_value) const { return (value_ <= static_cast< uint8_t>(_value)); }
        inline bool operator>=(const Literal &_value) const { return (value_ >= static_cast< uint8_t>(_value)); }
        inline bool operator<(const Literal &_value) const { return (value_ < static_cast< uint8_t>(_value)); }
        inline bool operator>(const Literal &_value) const { return (value_ > static_cast< uint8_t>(_value)); }
    
        const char* toString() const noexcept
        {
            switch(value_)
            {
            case static_cast< uint8_t>(Literal::NOERROR): return "NOERROR";
            case static_cast< uint8_t>(Literal::ERROR): return "ERROR";
            default: return "UNDEFINED";
            }
        }
    };
    
    struct AudioDeviceType : CommonAPI::Enumeration< uint8_t> {
        enum Literal : uint8_t {
            SPEAKER_ALL = 0,
            BT_A2DP_HEADPHONE_LEFT = 1,
            BT_A2DP_HEADPHONE_RIGHT = 2
        };
    
        AudioDeviceType()
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(Literal::SPEAKER_ALL)) {}
        AudioDeviceType(Literal _literal)
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(_literal)) {}
    
        inline bool validate() const {
            switch (value_) {
                case static_cast< uint8_t>(Literal::SPEAKER_ALL):
                case static_cast< uint8_t>(Literal::BT_A2DP_HEADPHONE_LEFT):
                case static_cast< uint8_t>(Literal::BT_A2DP_HEADPHONE_RIGHT):
                return true;
            default:
                return false;
            }
        }
    
        inline bool operator==(const AudioDeviceType &_other) const { return (value_ == _other.value_); }
        inline bool operator!=(const AudioDeviceType &_other) const { return (value_ != _other.value_); }
        inline bool operator<=(const AudioDeviceType &_other) const { return (value_ <= _other.value_); }
        inline bool operator>=(const AudioDeviceType &_other) const { return (value_ >= _other.value_); }
        inline bool operator<(const AudioDeviceType &_other) const { return (value_ < _other.value_); }
        inline bool operator>(const AudioDeviceType &_other) const { return (value_ > _other.value_); }
    
        inline bool operator==(const Literal &_value) const { return (value_ == static_cast< uint8_t>(_value)); }
        inline bool operator!=(const Literal &_value) const { return (value_ != static_cast< uint8_t>(_value)); }
        inline bool operator<=(const Literal &_value) const { return (value_ <= static_cast< uint8_t>(_value)); }
        inline bool operator>=(const Literal &_value) const { return (value_ >= static_cast< uint8_t>(_value)); }
        inline bool operator<(const Literal &_value) const { return (value_ < static_cast< uint8_t>(_value)); }
        inline bool operator>(const Literal &_value) const { return (value_ > static_cast< uint8_t>(_value)); }
    
        const char* toString() const noexcept
        {
            switch(value_)
            {
            case static_cast< uint8_t>(Literal::SPEAKER_ALL): return "SPEAKER_ALL";
            case static_cast< uint8_t>(Literal::BT_A2DP_HEADPHONE_LEFT): return "BT_A2DP_HEADPHONE_LEFT";
            case static_cast< uint8_t>(Literal::BT_A2DP_HEADPHONE_RIGHT): return "BT_A2DP_HEADPHONE_RIGHT";
            default: return "UNDEFINED";
            }
        }
    };
    
    struct AudioFocusResultType : CommonAPI::Enumeration< uint8_t> {
        enum Literal : uint8_t {
            ALREADY_EXIST = 0,
            NOT_POSSIBLE = 1,
            OK = 2,
            OK_PENDED = 3,
            DENY = 4,
            ERROR = 5
        };
    
        AudioFocusResultType()
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(Literal::ALREADY_EXIST)) {}
        AudioFocusResultType(Literal _literal)
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(_literal)) {}
    
        inline bool validate() const {
            switch (value_) {
                case static_cast< uint8_t>(Literal::ALREADY_EXIST):
                case static_cast< uint8_t>(Literal::NOT_POSSIBLE):
                case static_cast< uint8_t>(Literal::OK):
                case static_cast< uint8_t>(Literal::OK_PENDED):
                case static_cast< uint8_t>(Literal::DENY):
                case static_cast< uint8_t>(Literal::ERROR):
                return true;
            default:
                return false;
            }
        }
    
        inline bool operator==(const AudioFocusResultType &_other) const { return (value_ == _other.value_); }
        inline bool operator!=(const AudioFocusResultType &_other) const { return (value_ != _other.value_); }
        inline bool operator<=(const AudioFocusResultType &_other) const { return (value_ <= _other.value_); }
        inline bool operator>=(const AudioFocusResultType &_other) const { return (value_ >= _other.value_); }
        inline bool operator<(const AudioFocusResultType &_other) const { return (value_ < _other.value_); }
        inline bool operator>(const AudioFocusResultType &_other) const { return (value_ > _other.value_); }
    
        inline bool operator==(const Literal &_value) const { return (value_ == static_cast< uint8_t>(_value)); }
        inline bool operator!=(const Literal &_value) const { return (value_ != static_cast< uint8_t>(_value)); }
        inline bool operator<=(const Literal &_value) const { return (value_ <= static_cast< uint8_t>(_value)); }
        inline bool operator>=(const Literal &_value) const { return (value_ >= static_cast< uint8_t>(_value)); }
        inline bool operator<(const Literal &_value) const { return (value_ < static_cast< uint8_t>(_value)); }
        inline bool operator>(const Literal &_value) const { return (value_ > static_cast< uint8_t>(_value)); }
    
        const char* toString() const noexcept
        {
            switch(value_)
            {
            case static_cast< uint8_t>(Literal::ALREADY_EXIST): return "ALREADY_EXIST";
            case static_cast< uint8_t>(Literal::NOT_POSSIBLE): return "NOT_POSSIBLE";
            case static_cast< uint8_t>(Literal::OK): return "OK";
            case static_cast< uint8_t>(Literal::OK_PENDED): return "OK_PENDED";
            case static_cast< uint8_t>(Literal::DENY): return "DENY";
            case static_cast< uint8_t>(Literal::ERROR): return "ERROR";
            default: return "UNDEFINED";
            }
        }
    };
    
    struct FocusControlError : CommonAPI::Enumeration< uint8_t> {
        enum Literal : uint8_t {
            NOERROR = 0,
            INVALIDARGUMENTS = 1,
            FAILED = 2
        };
    
        FocusControlError()
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(Literal::NOERROR)) {}
        FocusControlError(Literal _literal)
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(_literal)) {}
    
        inline bool validate() const {
            switch (value_) {
                case static_cast< uint8_t>(Literal::NOERROR):
                case static_cast< uint8_t>(Literal::INVALIDARGUMENTS):
                case static_cast< uint8_t>(Literal::FAILED):
                return true;
            default:
                return false;
            }
        }
    
        inline bool operator==(const FocusControlError &_other) const { return (value_ == _other.value_); }
        inline bool operator!=(const FocusControlError &_other) const { return (value_ != _other.value_); }
        inline bool operator<=(const FocusControlError &_other) const { return (value_ <= _other.value_); }
        inline bool operator>=(const FocusControlError &_other) const { return (value_ >= _other.value_); }
        inline bool operator<(const FocusControlError &_other) const { return (value_ < _other.value_); }
        inline bool operator>(const FocusControlError &_other) const { return (value_ > _other.value_); }
    
        inline bool operator==(const Literal &_value) const { return (value_ == static_cast< uint8_t>(_value)); }
        inline bool operator!=(const Literal &_value) const { return (value_ != static_cast< uint8_t>(_value)); }
        inline bool operator<=(const Literal &_value) const { return (value_ <= static_cast< uint8_t>(_value)); }
        inline bool operator>=(const Literal &_value) const { return (value_ >= static_cast< uint8_t>(_value)); }
        inline bool operator<(const Literal &_value) const { return (value_ < static_cast< uint8_t>(_value)); }
        inline bool operator>(const Literal &_value) const { return (value_ > static_cast< uint8_t>(_value)); }
    
        const char* toString() const noexcept
        {
            switch(value_)
            {
            case static_cast< uint8_t>(Literal::NOERROR): return "NOERROR";
            case static_cast< uint8_t>(Literal::INVALIDARGUMENTS): return "INVALIDARGUMENTS";
            case static_cast< uint8_t>(Literal::FAILED): return "FAILED";
            default: return "UNDEFINED";
            }
        }
    };
    
    struct AudioFocusStatusType : CommonAPI::Enumeration< uint8_t> {
        enum Literal : uint8_t {
            GET = 0,
            LOSS = 1,
            PENDING = 2,
            UNPENDING = 3
        };
    
        AudioFocusStatusType()
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(Literal::GET)) {}
        AudioFocusStatusType(Literal _literal)
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(_literal)) {}
    
        inline bool validate() const {
            switch (value_) {
                case static_cast< uint8_t>(Literal::GET):
                case static_cast< uint8_t>(Literal::LOSS):
                case static_cast< uint8_t>(Literal::PENDING):
                case static_cast< uint8_t>(Literal::UNPENDING):
                return true;
            default:
                return false;
            }
        }
    
        inline bool operator==(const AudioFocusStatusType &_other) const { return (value_ == _other.value_); }
        inline bool operator!=(const AudioFocusStatusType &_other) const { return (value_ != _other.value_); }
        inline bool operator<=(const AudioFocusStatusType &_other) const { return (value_ <= _other.value_); }
        inline bool operator>=(const AudioFocusStatusType &_other) const { return (value_ >= _other.value_); }
        inline bool operator<(const AudioFocusStatusType &_other) const { return (value_ < _other.value_); }
        inline bool operator>(const AudioFocusStatusType &_other) const { return (value_ > _other.value_); }
    
        inline bool operator==(const Literal &_value) const { return (value_ == static_cast< uint8_t>(_value)); }
        inline bool operator!=(const Literal &_value) const { return (value_ != static_cast< uint8_t>(_value)); }
        inline bool operator<=(const Literal &_value) const { return (value_ <= static_cast< uint8_t>(_value)); }
        inline bool operator>=(const Literal &_value) const { return (value_ >= static_cast< uint8_t>(_value)); }
        inline bool operator<(const Literal &_value) const { return (value_ < static_cast< uint8_t>(_value)); }
        inline bool operator>(const Literal &_value) const { return (value_ > static_cast< uint8_t>(_value)); }
    
        const char* toString() const noexcept
        {
            switch(value_)
            {
            case static_cast< uint8_t>(Literal::GET): return "GET";
            case static_cast< uint8_t>(Literal::LOSS): return "LOSS";
            case static_cast< uint8_t>(Literal::PENDING): return "PENDING";
            case static_cast< uint8_t>(Literal::UNPENDING): return "UNPENDING";
            default: return "UNDEFINED";
            }
        }
    };
    
    struct VolumeControlError : CommonAPI::Enumeration< uint8_t> {
        enum Literal : uint8_t {
            NOERROR = 0,
            INVALIDARGUMENTS = 1,
            INVALIDRANGE = 2,
            FAILED = 3
        };
    
        VolumeControlError()
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(Literal::NOERROR)) {}
        VolumeControlError(Literal _literal)
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(_literal)) {}
    
        inline bool validate() const {
            switch (value_) {
                case static_cast< uint8_t>(Literal::NOERROR):
                case static_cast< uint8_t>(Literal::INVALIDARGUMENTS):
                case static_cast< uint8_t>(Literal::INVALIDRANGE):
                case static_cast< uint8_t>(Literal::FAILED):
                return true;
            default:
                return false;
            }
        }
    
        inline bool operator==(const VolumeControlError &_other) const { return (value_ == _other.value_); }
        inline bool operator!=(const VolumeControlError &_other) const { return (value_ != _other.value_); }
        inline bool operator<=(const VolumeControlError &_other) const { return (value_ <= _other.value_); }
        inline bool operator>=(const VolumeControlError &_other) const { return (value_ >= _other.value_); }
        inline bool operator<(const VolumeControlError &_other) const { return (value_ < _other.value_); }
        inline bool operator>(const VolumeControlError &_other) const { return (value_ > _other.value_); }
    
        inline bool operator==(const Literal &_value) const { return (value_ == static_cast< uint8_t>(_value)); }
        inline bool operator!=(const Literal &_value) const { return (value_ != static_cast< uint8_t>(_value)); }
        inline bool operator<=(const Literal &_value) const { return (value_ <= static_cast< uint8_t>(_value)); }
        inline bool operator>=(const Literal &_value) const { return (value_ >= static_cast< uint8_t>(_value)); }
        inline bool operator<(const Literal &_value) const { return (value_ < static_cast< uint8_t>(_value)); }
        inline bool operator>(const Literal &_value) const { return (value_ > static_cast< uint8_t>(_value)); }
    
        const char* toString() const noexcept
        {
            switch(value_)
            {
            case static_cast< uint8_t>(Literal::NOERROR): return "NOERROR";
            case static_cast< uint8_t>(Literal::INVALIDARGUMENTS): return "INVALIDARGUMENTS";
            case static_cast< uint8_t>(Literal::INVALIDRANGE): return "INVALIDRANGE";
            case static_cast< uint8_t>(Literal::FAILED): return "FAILED";
            default: return "UNDEFINED";
            }
        }
    };
    
    struct VolumeControl : CommonAPI::Enumeration< uint8_t> {
        enum Literal : uint8_t {
            MUTE = 0,
            UNMUTE = 1,
            VOL_UP = 2,
            VOL_DOWN = 3,
            MAX = 4
        };
    
        VolumeControl()
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(Literal::MUTE)) {}
        VolumeControl(Literal _literal)
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(_literal)) {}
    
        inline bool validate() const {
            switch (value_) {
                case static_cast< uint8_t>(Literal::MUTE):
                case static_cast< uint8_t>(Literal::UNMUTE):
                case static_cast< uint8_t>(Literal::VOL_UP):
                case static_cast< uint8_t>(Literal::VOL_DOWN):
                case static_cast< uint8_t>(Literal::MAX):
                return true;
            default:
                return false;
            }
        }
    
        inline bool operator==(const VolumeControl &_other) const { return (value_ == _other.value_); }
        inline bool operator!=(const VolumeControl &_other) const { return (value_ != _other.value_); }
        inline bool operator<=(const VolumeControl &_other) const { return (value_ <= _other.value_); }
        inline bool operator>=(const VolumeControl &_other) const { return (value_ >= _other.value_); }
        inline bool operator<(const VolumeControl &_other) const { return (value_ < _other.value_); }
        inline bool operator>(const VolumeControl &_other) const { return (value_ > _other.value_); }
    
        inline bool operator==(const Literal &_value) const { return (value_ == static_cast< uint8_t>(_value)); }
        inline bool operator!=(const Literal &_value) const { return (value_ != static_cast< uint8_t>(_value)); }
        inline bool operator<=(const Literal &_value) const { return (value_ <= static_cast< uint8_t>(_value)); }
        inline bool operator>=(const Literal &_value) const { return (value_ >= static_cast< uint8_t>(_value)); }
        inline bool operator<(const Literal &_value) const { return (value_ < static_cast< uint8_t>(_value)); }
        inline bool operator>(const Literal &_value) const { return (value_ > static_cast< uint8_t>(_value)); }
    
        const char* toString() const noexcept
        {
            switch(value_)
            {
            case static_cast< uint8_t>(Literal::MUTE): return "MUTE";
            case static_cast< uint8_t>(Literal::UNMUTE): return "UNMUTE";
            case static_cast< uint8_t>(Literal::VOL_UP): return "VOL_UP";
            case static_cast< uint8_t>(Literal::VOL_DOWN): return "VOL_DOWN";
            case static_cast< uint8_t>(Literal::MAX): return "MAX";
            default: return "UNDEFINED";
            }
        }
    };
    
    struct AudioChannel : CommonAPI::Enumeration< uint8_t> {
        enum Literal : uint8_t {
            MONO = 0,
            STEREO = 1,
            FIVE_1 = 2,
            SEVEN_1 = 3
        };
    
        AudioChannel()
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(Literal::MONO)) {}
        AudioChannel(Literal _literal)
            : CommonAPI::Enumeration< uint8_t>(static_cast< uint8_t>(_literal)) {}
    
        inline bool validate() const {
            switch (value_) {
                case static_cast< uint8_t>(Literal::MONO):
                case static_cast< uint8_t>(Literal::STEREO):
                case static_cast< uint8_t>(Literal::FIVE_1):
                case static_cast< uint8_t>(Literal::SEVEN_1):
                return true;
            default:
                return false;
            }
        }
    
        inline bool operator==(const AudioChannel &_other) const { return (value_ == _other.value_); }
        inline bool operator!=(const AudioChannel &_other) const { return (value_ != _other.value_); }
        inline bool operator<=(const AudioChannel &_other) const { return (value_ <= _other.value_); }
        inline bool operator>=(const AudioChannel &_other) const { return (value_ >= _other.value_); }
        inline bool operator<(const AudioChannel &_other) const { return (value_ < _other.value_); }
        inline bool operator>(const AudioChannel &_other) const { return (value_ > _other.value_); }
    
        inline bool operator==(const Literal &_value) const { return (value_ == static_cast< uint8_t>(_value)); }
        inline bool operator!=(const Literal &_value) const { return (value_ != static_cast< uint8_t>(_value)); }
        inline bool operator<=(const Literal &_value) const { return (value_ <= static_cast< uint8_t>(_value)); }
        inline bool operator>=(const Literal &_value) const { return (value_ >= static_cast< uint8_t>(_value)); }
        inline bool operator<(const Literal &_value) const { return (value_ < static_cast< uint8_t>(_value)); }
        inline bool operator>(const Literal &_value) const { return (value_ > static_cast< uint8_t>(_value)); }
    
        const char* toString() const noexcept
        {
            switch(value_)
            {
            case static_cast< uint8_t>(Literal::MONO): return "MONO";
            case static_cast< uint8_t>(Literal::STEREO): return "STEREO";
            case static_cast< uint8_t>(Literal::FIVE_1): return "FIVE_1";
            case static_cast< uint8_t>(Literal::SEVEN_1): return "SEVEN_1";
            default: return "UNDEFINED";
            }
        }
    };
    struct FocusStatus : CommonAPI::Struct< std::string, AudioDeviceType, AudioFocusStatusType> {
    
        FocusStatus()
        {
            std::get< 0>(values_) = "";
            std::get< 1>(values_) = AudioDeviceType();
            std::get< 2>(values_) = AudioFocusStatusType();
        }
        FocusStatus(const std::string &_audioSourceType, const AudioDeviceType &_device, const AudioFocusStatusType &_status)
        {
            std::get< 0>(values_) = _audioSourceType;
            std::get< 1>(values_) = _device;
            std::get< 2>(values_) = _status;
        }
        inline const std::string &getAudioSourceType() const { return std::get< 0>(values_); }
        inline void setAudioSourceType(const std::string &_value) { std::get< 0>(values_) = _value; }
        inline const AudioDeviceType &getDevice() const { return std::get< 1>(values_); }
        inline void setDevice(const AudioDeviceType &_value) { std::get< 1>(values_) = _value; }
        inline const AudioFocusStatusType &getStatus() const { return std::get< 2>(values_); }
        inline void setStatus(const AudioFocusStatusType &_value) { std::get< 2>(values_) = _value; }
        inline bool operator==(const FocusStatus& _other) const {
        return (getAudioSourceType() == _other.getAudioSourceType() && getDevice() == _other.getDevice() && getStatus() == _other.getStatus());
        }
        inline bool operator!=(const FocusStatus &_other) const {
            return !((*this) == _other);
        }
    
    };
    struct VolumeInfo : CommonAPI::Struct< uint8_t, uint8_t, uint8_t, bool> {
    
        VolumeInfo()
        {
            std::get< 0>(values_) = 0u;
            std::get< 1>(values_) = 0u;
            std::get< 2>(values_) = 0u;
            std::get< 3>(values_) = false;
        }
        VolumeInfo(const uint8_t &_volume, const uint8_t &_maxSoftVolume, const uint8_t &_lastVolume, const bool &_mute)
        {
            std::get< 0>(values_) = _volume;
            std::get< 1>(values_) = _maxSoftVolume;
            std::get< 2>(values_) = _lastVolume;
            std::get< 3>(values_) = _mute;
        }
        inline const uint8_t &getVolume() const { return std::get< 0>(values_); }
        inline void setVolume(const uint8_t &_value) { std::get< 0>(values_) = _value; }
        inline const uint8_t &getMaxSoftVolume() const { return std::get< 1>(values_); }
        inline void setMaxSoftVolume(const uint8_t &_value) { std::get< 1>(values_) = _value; }
        inline const uint8_t &getLastVolume() const { return std::get< 2>(values_); }
        inline void setLastVolume(const uint8_t &_value) { std::get< 2>(values_) = _value; }
        inline const bool &getMute() const { return std::get< 3>(values_); }
        inline void setMute(const bool _value) { std::get< 3>(values_) = _value; }
        inline bool operator==(const VolumeInfo& _other) const {
        return (getVolume() == _other.getVolume() && getMaxSoftVolume() == _other.getMaxSoftVolume() && getLastVolume() == _other.getLastVolume() && getMute() == _other.getMute());
        }
        inline bool operator!=(const VolumeInfo &_other) const {
            return !((*this) == _other);
        }
    
    };
    struct AudioSourceStatusInfo : CommonAPI::Struct< std::string, FocusStatus, VolumeInfo> {
    
        AudioSourceStatusInfo()
        {
            std::get< 0>(values_) = "";
            std::get< 1>(values_) = FocusStatus();
            std::get< 2>(values_) = VolumeInfo();
        }
        AudioSourceStatusInfo(const std::string &_audioSourceType, const FocusStatus &_focusStatus, const VolumeInfo &_volumeInfo)
        {
            std::get< 0>(values_) = _audioSourceType;
            std::get< 1>(values_) = _focusStatus;
            std::get< 2>(values_) = _volumeInfo;
        }
        inline const std::string &getAudioSourceType() const { return std::get< 0>(values_); }
        inline void setAudioSourceType(const std::string &_value) { std::get< 0>(values_) = _value; }
        inline const FocusStatus &getFocusStatus() const { return std::get< 1>(values_); }
        inline void setFocusStatus(const FocusStatus &_value) { std::get< 1>(values_) = _value; }
        inline const VolumeInfo &getVolumeInfo() const { return std::get< 2>(values_); }
        inline void setVolumeInfo(const VolumeInfo &_value) { std::get< 2>(values_) = _value; }
        inline bool operator==(const AudioSourceStatusInfo& _other) const {
        return (getAudioSourceType() == _other.getAudioSourceType() && getFocusStatus() == _other.getFocusStatus() && getVolumeInfo() == _other.getVolumeInfo());
        }
        inline bool operator!=(const AudioSourceStatusInfo &_other) const {
            return !((*this) == _other);
        }
    
    };
    typedef std::unordered_map< std::string, std::string> KeyValueString;
    typedef std::unordered_map< ::v2::Test::Audio::Controller::AudioDeviceType, ::v2::Test::Audio::Controller::AudioFocusStatusType, CommonAPI::EnumHasher< ::v2::Test::Audio::Controller::AudioDeviceType>> DeviceStateMap;
    typedef std::unordered_map< uint32_t, CommonAPI::ByteBuffer> KeyValueByteBuffer;
    typedef std::unordered_map< std::string, uint16_t> StringToShortMap;
};

const char* Controller::getInterface() {
    return ("Test.Audio.Controller:v2_0");
}

CommonAPI::Version Controller::getInterfaceVersion() {
    return CommonAPI::Version(2, 0);
}


} // namespace Audio
} // namespace Test
} // namespace v2

namespace CommonAPI {
}


// Compatibility
namespace v2_0 = v2;

#endif // V2_TEST_AUDIO_CONTROLLER_HPP_
